<?php
/**
 * @version     1.0.0
 * @package     com_docebo
 * @copyright   Copyright (C) 2013. All rights reserved.
 * @license     GNU General Public License version 2 or later; see LICENSE.txt
 * @author      Docebo Srl. <info@docebo.com> - http://www.docebo.com
 */

// no direct access
defined('_JEXEC') or die;

JHtml::_('behavior.tooltip');
JHtml::_('behavior.formvalidation');
JHtml::_('behavior.keepalive');
// Import CSS
$document = JFactory::getDocument();
$document->addStyleSheet('components/com_docebo/assets/css/docebo.css');
?>
<script src="//ajax.googleapis.com/ajax/libs/jquery/1.8.3/jquery.min.js"></script>
<script type="text/javascript">
	Joomla.submitbutton = function (task) {

		if (task == 'singlesignon.cancel' || document.formvalidator.isValid(document.id('singlesignon-form'))) {
			Joomla.submitform(task, document.getElementById('singlesignon-form'));
		}
		else {
			alert('<?php echo $this->escape(JText::_('JGLOBAL_VALIDATION_FORM_FAILED'));?>');
		}
	}
</script>
<form action="<?php echo JRoute::_('index.php?option=com_docebo&layout=edit&id=' . (int) $this->item->id); ?>"
      method="post" enctype="multipart/form-data" name="adminForm" id="singlesignon-form" class="form-validate"
      style="float:left; width: 60%;">
	<div class="width-60 fltlft" style="width: 100% !important;">
		<fieldset class="adminform">
			<legend><?php echo JText::_('COM_DOCEBO_LEGEND_SINGLESIGNON'); ?></legend>
			<ul class="adminformlist">
				<input type="hidden" name="jform[id]" value="<?php echo $this->item->id; ?>"/>
				<li><?php echo $this->form->getLabel('box_title'); ?>
					<?php echo $this->form->getInput('box_title'); ?></li>
				<li><?php echo $this->form->getLabel('intro_text'); ?>
					<?php echo $this->form->getInput('intro_text'); ?></li>
				<li><?php echo $this->form->getLabel('box_width'); ?>
					<?php echo $this->form->getInput('box_width'); ?></li>
				<li><?php echo $this->form->getLabel('box_height'); ?>
					<?php echo $this->form->getInput('box_height'); ?></li>
				<li><?php echo $this->form->getLabel('sso_button_text'); ?>
					<?php echo $this->form->getInput('sso_button_text'); ?></li>
				<li><?php echo $this->form->getLabel('button_position'); ?>
					<?php echo $this->form->getInput('button_position'); ?></li>
				<li><?php echo $this->form->getLabel('show_courses_you_are_enrolled_in'); ?>
					<?php echo $this->form->getInput('show_courses_you_are_enrolled_in'); ?></li>
				<li><?php echo $this->form->getLabel('show_last_attended_course'); ?>
					<?php echo $this->form->getInput('show_last_attended_course'); ?></li>
				<li><?php echo $this->form->getLabel('text_color'); ?>
					<?php echo $this->form->getInput('text_color'); ?></li>
				<li><?php echo $this->form->getLabel('title_color'); ?>
					<?php echo $this->form->getInput('title_color'); ?></li>
				<li><?php echo $this->form->getLabel('border_color'); ?>
					<?php echo $this->form->getInput('border_color'); ?></li>
				<li><?php echo $this->form->getLabel('background_color'); ?>
					<?php echo $this->form->getInput('background_color'); ?></li>
				<li><?php echo $this->form->getLabel('use_box_shadow'); ?>
					<?php echo $this->form->getInput('use_box_shadow'); ?></li>
				<li><?php echo $this->form->getLabel('button_background_color'); ?>
					<?php echo $this->form->getInput('button_background_color'); ?></li>
				<li><?php echo $this->form->getLabel('button_border_color'); ?>
					<?php echo $this->form->getInput('button_border_color'); ?></li>
				<li><?php echo $this->form->getLabel('button_text_color'); ?>
					<?php echo $this->form->getInput('button_text_color'); ?></li>
			</ul>
		</fieldset>
	</div>
	<input type="hidden" name="task" value=""/>
	<?php echo JHtml::_('form.token'); ?>
	<div class="clr"></div>
	<style type="text/css">
		/* Temporary fix for drifting editor fields */
		.adminformlist li {
			clear: both;
		}
	</style>
</form>

<!-- Generate a preview -->
<div id="docebo-preview-panel" style="float: right; position: relative; right: 20px; top: 20px;">
	<h4 style="text-align:center;"><?php echo JText::_('COM_DOCEBO_PREVIEW') ?></h4>
	<?php
	$sync_scene = DoceboViewSinglesignon::check_sync_scene();
	if ($sync_scene == '0') {
		?>
		<style>
			/* --------------------------------------------------- */
			/* SSO Box preview
			/* --------------------------------------------------- */
			#docebo-sso-box {
				border-radius:         3px;
				-moz-border-radius:    3px;
				-webkit-border-radius: 3px;
			}

			#docebo-sso-box .sso-container {
				padding: 15px;
			}

			#docebo-sso-box .course-overview {
				margin: 10px 0;
			}

			#docebo-sso-box h3 {
				margin-top: 0;
				font-size:  18px;
			}

			#docebo-sso-box h4 {
				margin-top:         0;
				margin-bottom:      10px;
				font-size:          15px;
				padding-bottom:     5px;
				border-bottom:      1px solid #ccc;
				-moz-box-shadow:    0px 1px 0px #fff;
				-webkit-box-shadow: 0px 1px 0px #fff;
				box-shadow:         0px 1px 0px #fff;
			}

			#docebo-sso-box img {
				width:        50px;
				height:       50px;
				padding:      1px;
				background:   #fff;
				border:       1px solid #ccc;
				float:        left;
				margin-right: 3px;
			}

			#docebo-sso-box .new-courses {
				background:   url(<?php echo JURI::base(); ?>components/com_docebo/assets/images/icon_new_courses.png) left center no-repeat;
				padding-left: 25px;
				line-height:  24px;
			}

			#docebo-sso-box .inprogress-courses {
				background:   url(<?php echo JURI::base(); ?>components/com_docebo/assets/images/icon_in_progress.png) left center no-repeat;
				padding-left: 25px;
				line-height:  24px;
			}

			#docebo-sso-box .completed-courses {
				background:   url(<?php echo JURI::base(); ?>components/com_docebo/assets/images/icon_completed.png) left center no-repeat;
				padding-left: 25px;
				line-height:  24px;
			}

			#docebo-sso-box span.number {
				float:       right;
				font-weight: 700;
			}

			#docebo-sso-box .last-course {
				float:         left;
				width:         100%;
				margin-bottom: 35px;
			}

			#docebo-sso-box .last-course .last-course-meta {
				margin-left: 15px;
			}

			#docebo-sso-box .last-course .last-course-meta h4 {
				margin:             0 0 10px;
				font-weight:        400;
				font-size:          13px;
				border:             none;
				box-shadow:         none;
				-webkit-box-shadow: none;
				-moz-box-shadow:    none;
			}

			#docebo-sso-box .last-course .progress {
				width:      100%;
				height:     10px;
				background: #ccc;
				margin-top: 10px;
			}

			#docebo-sso-box .last-course .bar {
				height:     10px;
				background: #85b200;
			}

			a.docebo-button {
				padding:         7px 10px;
				text-decoration: none;
				font-weight:     700;
			}
		</style>
		<?php
		$user = JFactory::getUser();
		$docebo_username = $user->get('username');
		// Let's create the SSO box, first call the API
		$params = array(
			'ext_user'      => $user->get('id'),
			'ext_user_type' => 'wordpress',
		);
		$data = Api::call('user/getstat/', $params);
		$course_block = json_decode($data);

		// Get the data for the current WordPress user through the LMS API
		$params = array(
			'ext_user'      => $user->get('id'),
			'ext_user_type' => 'wordpress',
		);
		$data = Api::call('user/profile/', $params);
		if ($data) // API success
		{
			// Parse the received user data
			$docebo_user_info = json_decode($data);
			if (isset($docebo_user_info->userid)) {
				$docebo_username = $docebo_user_info->userid;
				//echo 'UserName: '.$docebo_username;
			}
		}

		$button_link = Api::sso($docebo_username);

		//get SSO custom details from DB
		$dwp_sso_options = DoceboViewSinglesignon::get_sso_customs();

		?>
		<div id="docebo-sso-box"
		     style="background: <?php echo $dwp_sso_options['background_color']; ?>; width: <?php echo $dwp_sso_options['box_width']; ?>px; min-height: <?php echo $dwp_sso_options['box_height']; ?>px; color: <?php echo $dwp_sso_options['text_color']; ?>; border: 1px solid <?php echo $dwp_sso_options['border_color']; ?>; <?php if ($dwp_sso_options['use_box_shadow'] == 'Yes') {
			     echo 'box-shadow: 0 0 8px rgba(0,0,0,0.30)';
		     } ?>">
			<div class="sso-container">

				<?php if ($dwp_sso_options['box_title']) { ?>
					<h2 style="color: <?php echo $dwp_sso_options['title_color']; ?>"><?php echo $dwp_sso_options['box_title']; ?></h2>
				<?php } ?>

				<?php if ($dwp_sso_options['intro_text']) { ?>
					<h3 style="color: <?php echo $dwp_sso_options['title_color']; ?>"><?php echo $dwp_sso_options['intro_text']; ?></h3>
				<?php } ?>

				<?php if ($dwp_sso_options['show_courses_you_are_enrolled_in']): ?>
					<div class="course-overview">
						<h4 style="color: <?php echo $dwp_sso_options['title_color']; ?>"><?=JText::_('COM_DOCEBO_FORM_LBL_SINGLESIGNON_BOX_TITLE')?></h4>
						<?php
						echo '<div class="new-courses">'.JText::_('COM_DOCEBO_NEW').'</span><span class="number">' . (isset($course_block->user_courses->new_courses) ? $course_block->user_courses->new_courses : 0) . '</div>';
						echo '<div class="inprogress-courses">'.JText::_('COM_DOCEBO_IN_PROGRESS').'</span><span class="number">' . (isset($course_block->user_courses->in_progress) ? $course_block->user_courses->in_progress : 0) . '</div>';
						echo '<div class="completed-courses">'.JText::_('COM_DOCEBO_COMPLETED').'</span><span class="number">' . (isset($course_block->user_courses->completed) ? $course_block->user_courses->completed : 0) . '</div>';
						?>
					</div>
				<?php endif; ?>

				<?php if (isset($course_block->last_course) && !empty($course_block->last_course) && $dwp_sso_options['show_last_attended_course']) { ?>
					<div class="last-course">
						<h4 style="color: <?php echo $dwp_sso_options['title_color']; ?>"><?php echo JText::_('COM_DOCEBO_SINGLESIGNONS_LAST_ATTENDED_COURSE')?></h4>
						<?php    echo '<img class="course-thumb" src="' . $course_block->last_course->course_thumbnail . '" />';
						echo '<div class="last-course-meta"><h4 style="color: ' . $dwp_sso_options['title_color'] . '">' . $course_block->last_course->course_title . '</h4>';
						echo JText::_('COM_DOCEBO_SINGLESIGNONS_COURSE_PROGRESS');
						echo '<div class="progress"><div class="bar" style="width: ' . $course_block->last_course->course_progress . '%;"></div></div></div><div class="clear"></div>'; ?>
					</div>
				<?php } ?>

				<div class="cloud-button"
				     style="text-align: <?php echo $dwp_sso_options['button_position']; ?>;">
					<a href="<?php echo $button_link; ?>" target="_blank" class="docebo-button"
					   style="background: <?php echo $dwp_sso_options['button_background_color']; ?>; color: <?php echo $dwp_sso_options['button_text_color']; ?>; border: 1px solid <?php echo $dwp_sso_options['button_border_color']; ?>;"><?php echo($dwp_sso_options['sso_button_text'] ? $dwp_sso_options['sso_button_text'] : 'SIGN IN'); ?></a>
				</div>
			</div>
		</div>
		<!-- end #docebo-preview-panel -->
	<?php

	} else {
		echo '<p class="error">' . JText::_('COM_DOCEBO_SINGLESIGNONS_NOT_ENABLED') . '</p>';
	} ?>
</div>